//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DimGray
#property indicator_color2 C'0,128,0'
#property indicator_color3 C'128,0,0'
#property indicator_color4 C'0,192,0'
#property indicator_color5 C'192,0,0'
#property indicator_color6 C'0,255,0'
#property indicator_color7 C'255,0,0'
//---- indicator parameters
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsFiboDeviation1=1.618;
extern double BandsFiboDeviation2=2.618;
extern double BandsFiboDeviation3=3.618;
//---- buffers
double MovingBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,MovingBuffer);
   SetIndexBuffer(1,UpperBuffer1);
   SetIndexBuffer(2,LowerBuffer1);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexBuffer(4,LowerBuffer2);
   SetIndexBuffer(5,UpperBuffer3);
   SetIndexBuffer(6,LowerBuffer3);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);
           
   //
   //
   //
   //
   //
         
   for (i = limit; i >= 0; i--)
   {
       double StdDev   = iStdDev(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
       MovingBuffer[i] = iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
       UpperBuffer1[i] = MovingBuffer[i] + (StdDev*BandsFiboDeviation1);
       LowerBuffer1[i] = MovingBuffer[i] - (StdDev*BandsFiboDeviation1);
       UpperBuffer2[i] = MovingBuffer[i] + (StdDev*BandsFiboDeviation2);
       LowerBuffer2[i] = MovingBuffer[i] - (StdDev*BandsFiboDeviation2);
       UpperBuffer3[i] = MovingBuffer[i] + (StdDev*BandsFiboDeviation3);
       LowerBuffer3[i] = MovingBuffer[i] - (StdDev*BandsFiboDeviation3);
     }
   return(0);
  }
//+------------------------------------------------------------------+